import { Type } from "../types.js";
import { ValueValidator } from "../value/validator.js";
import { CoreValidator, TreeTraverser } from "../core/validator.js";
import { Writeable } from "../functional.js";
export declare class ArrayValidator<T extends Array<any>> extends ValueValidator<T, ArrayValidator<T>> {
    private validator;
    protected type: Type;
    private _unique;
    private _minItems;
    private _maxItems;
    private _contains;
    constructor(validator: CoreValidator<any>);
    const<V extends readonly T[number][]>(value: V): ArrayValidator<Writeable<typeof value>>;
    enum<V extends readonly T[number][]>(...values: V[]): ArrayValidator<Writeable<(typeof values)[number]>>;
    /**
     * ## Minimum number of items
     */
    minItems(min: number): this;
    /**
     * ## Maximum number of items
     */
    maxItems(max: number): this;
    contains(validator: CoreValidator<any>): this;
    unique(unique?: boolean): this;
    protected toSchema(traverser: TreeTraverser): {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems: number;
        contains: any;
        items: any;
        allOf?: undefined;
        anyOf?: undefined;
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems: number;
        contains: any;
        items: any;
        allOf?: undefined;
        anyOf?: undefined;
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems?: undefined;
        contains: any;
        items: any;
        allOf?: undefined;
        anyOf?: undefined;
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems?: undefined;
        contains: any;
        items: any;
        allOf?: undefined;
        anyOf?: undefined;
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems: number;
        contains?: undefined;
        items: any;
        allOf?: undefined;
        anyOf?: undefined;
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems: number;
        contains?: undefined;
        items: any;
        allOf?: undefined;
        anyOf?: undefined;
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems?: undefined;
        contains?: undefined;
        items: any;
        allOf?: undefined;
        anyOf?: undefined;
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems?: undefined;
        contains?: undefined;
        items: any;
        allOf?: undefined;
        anyOf?: undefined;
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems: number;
        contains: any;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf?: undefined;
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems: number;
        contains: any;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf?: undefined;
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems?: undefined;
        contains: any;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf?: undefined;
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems?: undefined;
        contains: any;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf?: undefined;
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems: number;
        contains?: undefined;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf?: undefined;
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems: number;
        contains?: undefined;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf?: undefined;
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems?: undefined;
        contains?: undefined;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf?: undefined;
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems?: undefined;
        contains?: undefined;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf?: undefined;
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems: number;
        contains: any;
        items: any;
        allOf?: undefined;
        anyOf: Omit<any, "type">[];
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems: number;
        contains: any;
        items: any;
        allOf?: undefined;
        anyOf: Omit<any, "type">[];
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems?: undefined;
        contains: any;
        items: any;
        allOf?: undefined;
        anyOf: Omit<any, "type">[];
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems?: undefined;
        contains: any;
        items: any;
        allOf?: undefined;
        anyOf: Omit<any, "type">[];
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems: number;
        contains?: undefined;
        items: any;
        allOf?: undefined;
        anyOf: Omit<any, "type">[];
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems: number;
        contains?: undefined;
        items: any;
        allOf?: undefined;
        anyOf: Omit<any, "type">[];
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems?: undefined;
        contains?: undefined;
        items: any;
        allOf?: undefined;
        anyOf: Omit<any, "type">[];
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems?: undefined;
        contains?: undefined;
        items: any;
        allOf?: undefined;
        anyOf: Omit<any, "type">[];
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems: number;
        contains: any;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf: Omit<any, "type">[];
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems: number;
        contains: any;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf: Omit<any, "type">[];
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems?: undefined;
        contains: any;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf: Omit<any, "type">[];
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems?: undefined;
        contains: any;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf: Omit<any, "type">[];
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems: number;
        contains?: undefined;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf: Omit<any, "type">[];
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems: number;
        contains?: undefined;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf: Omit<any, "type">[];
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems?: undefined;
        contains?: undefined;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf: Omit<any, "type">[];
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems?: undefined;
        contains?: undefined;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf: Omit<any, "type">[];
        default?: undefined;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems: number;
        contains: any;
        items: any;
        allOf?: undefined;
        anyOf?: undefined;
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems: number;
        contains: any;
        items: any;
        allOf?: undefined;
        anyOf?: undefined;
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems?: undefined;
        contains: any;
        items: any;
        allOf?: undefined;
        anyOf?: undefined;
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems?: undefined;
        contains: any;
        items: any;
        allOf?: undefined;
        anyOf?: undefined;
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems: number;
        contains?: undefined;
        items: any;
        allOf?: undefined;
        anyOf?: undefined;
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems: number;
        contains?: undefined;
        items: any;
        allOf?: undefined;
        anyOf?: undefined;
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems?: undefined;
        contains?: undefined;
        items: any;
        allOf?: undefined;
        anyOf?: undefined;
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems?: undefined;
        contains?: undefined;
        items: any;
        allOf?: undefined;
        anyOf?: undefined;
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems: number;
        contains: any;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf?: undefined;
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems: number;
        contains: any;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf?: undefined;
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems?: undefined;
        contains: any;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf?: undefined;
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems?: undefined;
        contains: any;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf?: undefined;
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems: number;
        contains?: undefined;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf?: undefined;
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems: number;
        contains?: undefined;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf?: undefined;
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems?: undefined;
        contains?: undefined;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf?: undefined;
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems?: undefined;
        contains?: undefined;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf?: undefined;
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems: number;
        contains: any;
        items: any;
        allOf?: undefined;
        anyOf: Omit<any, "type">[];
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems: number;
        contains: any;
        items: any;
        allOf?: undefined;
        anyOf: Omit<any, "type">[];
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems?: undefined;
        contains: any;
        items: any;
        allOf?: undefined;
        anyOf: Omit<any, "type">[];
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems?: undefined;
        contains: any;
        items: any;
        allOf?: undefined;
        anyOf: Omit<any, "type">[];
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems: number;
        contains?: undefined;
        items: any;
        allOf?: undefined;
        anyOf: Omit<any, "type">[];
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems: number;
        contains?: undefined;
        items: any;
        allOf?: undefined;
        anyOf: Omit<any, "type">[];
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems?: undefined;
        contains?: undefined;
        items: any;
        allOf?: undefined;
        anyOf: Omit<any, "type">[];
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems?: undefined;
        contains?: undefined;
        items: any;
        allOf?: undefined;
        anyOf: Omit<any, "type">[];
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems: number;
        contains: any;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf: Omit<any, "type">[];
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems: number;
        contains: any;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf: Omit<any, "type">[];
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems?: undefined;
        contains: any;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf: Omit<any, "type">[];
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems?: undefined;
        contains: any;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf: Omit<any, "type">[];
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems: number;
        contains?: undefined;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf: Omit<any, "type">[];
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems: number;
        contains?: undefined;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf: Omit<any, "type">[];
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems: number;
        minItems?: undefined;
        contains?: undefined;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf: Omit<any, "type">[];
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    } | {
        uniqueItems?: boolean | undefined;
        maxItems?: undefined;
        minItems?: undefined;
        contains?: undefined;
        items: any;
        allOf: Omit<any, "type">[];
        anyOf: Omit<any, "type">[];
        default: T;
        examples?: string[] | undefined;
        description?: string | undefined;
        title?: string | undefined;
        type: string;
    };
    protected clone(clean?: boolean): this;
}
